=== debian/control ===
Source: ros-iron-rtabmap
Section: misc
Priority: optional
Maintainer: Mathieu Labbe <matlabbe@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libpcl-dev, libproj-dev, libsqlite3-dev, ros-iron-cv-bridge, ros-iron-libg2o, ros-iron-libpointmatcher, ros-iron-octomap, ros-iron-qt-gui-cpp, zlib1g-dev, ros-iron-ros-workspace
Homepage: http://introlab.github.io/rtabmap
Standards-Version: 3.9.2

Package: ros-iron-rtabmap
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpcl-dev, libsqlite3-dev, ros-iron-cv-bridge, ros-iron-libg2o, ros-iron-libpointmatcher, ros-iron-octomap, ros-iron-qt-gui-cpp, zlib1g-dev, ros-iron-ros-workspace
Description: RTAB-Map's standalone library.
 RTAB-Map is a RGB-D SLAM approach with real-time constraints.
